<template>
  <div class="doc-example">
    <rui-toolbars class="doc-example__actions">
      <rui-toolbar>
        <rui-button icon="doc:cog"
                    text
                    :active="showOptions"
                    title="Preview options"
                    @click="showOptions = !showOptions" />
      </rui-toolbar>

      <div v-show="showOptions">
        <rui-toolbar label="Preview size">
          <rui-dropdown :caption="size">
            <rui-menu-item :active="size === 'tiny'" caption="&lt; small" @click="size='tiny'" />
            <rui-menu-item :active="size === 'small'" caption="small" @click="size='small'" />
            <rui-menu-item :active="size === 'medium'" caption="medium" @click="size='medium'" />
            <rui-menu-item :active="size === 'large'" caption="large" @click="size='large'" />
            <rui-menu-item :active="size === 'default'" caption="default" @click="size='default'" />
          </rui-dropdown>
        </rui-toolbar>

        <rui-toolbar label="Outline">
          <rui-button :caption="outline ? 'Yes' : 'No'" @click="outline = !outline" />
        </rui-toolbar>

        <rui-toolbar label="Theme">
          <rui-button caption="As docs" @click="useDocTheme" />
          <rui-button caption="Light" @click="theme = 'light'" />
          <rui-button caption="dark" @click="theme = 'dark'" />
        </rui-toolbar>

        <rui-toolbar label="Background">
          <rui-button :caption="checkedBackground ? 'Checkered' : 'Default'" @click="checkedBackground = !checkedBackground" />
        </rui-toolbar>

        <rui-toolbar label="Padding">
          <rui-button :caption="padding ? 'Yes' : 'No'" @click="padding = !padding" />
        </rui-toolbar>
      </div>
    </rui-toolbars>

    <div class="doc-example__wrapper">
      <div class="doc-example__content rui" :class="previewCSS" :style="previewStyle">
        <slot />
      </div>
    </div>

    <div v-if="$slots.aside" class="doc-example__aside"><slot name="aside" /></div>
  </div>
</template>

<script>
import { RuiButton, RuiDropdown, RuiMenuItem, RuiToolbar, RuiToolbars } from '../../../src/components/index.js'

export default {
  name: 'DocExampleWrapper',
  components: { RuiToolbars, RuiToolbar, RuiButton, RuiDropdown, RuiMenuItem },
  props: {
    /** Minimum height for the wrapper */
    minHeight: { required: false, type: String, default: null },
    /**
     * Custom background value
     *
     * @values null, checkboard
     */
    background: { required: false, type: String, default: null },
  },
  data () {
    return {
      showOptions: false,
      // Preview options
      size: 'default',
      outline: false,
      theme: this.$storage.theme,
      checkedBackground: this.background === 'checkboard',
      padding: false,
    }
  },
  computed: {
    previewCSS () {
      return [
        this.theme && `rui-theme--${this.theme}`,
        this.size && `doc-example__content--${this.size}`,
        this.checkedBackground && 'doc-example__content--checkered',
        this.outline && 'doc-example__content--outline',
        this.padding && 'doc-example__content--padded',
      ]
    },
    previewStyle () {
      return {
        minHeight: this.minHeight || null,
      }
    },
  },
  methods: {
    useDocTheme () {
      this.theme = this.$storage.theme
    },
  },
}
</script>
